"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rx = require("rxjs");
var system = require('system');
var CasperjsBinding = /** @class */ (function () {
    function CasperjsBinding(listenAdr, casper) {
        var _this = this;
        this.input = new rx.Subject();
        this.output = new rx.Subject();
        this.casper = casper;
        // write "output" to stdout
        this.output.subscribe(function (data) {
            console.log(data);
        }, function (err) {
            system.stderr.write(err);
            _this.casper.exit(1);
            _this.casper.bypass(1);
        }, function () {
            _this.casper.exit();
            _this.casper.bypass(1);
        });
        var server = require('webserver').create();
        this.listening = server.listen(listenAdr, function (request, response) {
            // consume input via HTTP request
            _this.input.next(request.postRaw);
            response.statusCode = 200;
            response.write('<html><body>casper theater</body></html>');
            response.close();
        });
    }
    return CasperjsBinding;
}());
exports.CasperjsBinding = CasperjsBinding;
exports.default = CasperjsBinding;
//# sourceMappingURL=casperjs-binding.js.map