"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rx = require("rxjs");
var message_payload_parser_1 = require("message-payload-parser");
var FindLastEndpoint = /** @class */ (function () {
    function FindLastEndpoint(first, last, down) {
        var _this = this;
        this.payloadParser = new message_payload_parser_1.default(first, last);
        this.output = new rx.Subject();
        this.input = new rx.Subject();
        this.output.subscribe(function (data) {
            down.output.next("" + _this.payloadParser.first + data + _this.payloadParser.last);
        }, function (err) {
            down.output.error(err);
        }, function () {
            down.output.complete();
        });
        down.input.subscribe(function (data) {
            _this.payloadParser.feed(data, 0, function (payload) {
                _this.input.next(payload);
            });
        }, function (err) {
            _this.input.error(err);
        }, function () {
            _this.input.complete();
        });
    }
    return FindLastEndpoint;
}());
exports.FindLastEndpoint = FindLastEndpoint;
exports.default = FindLastEndpoint;
//# sourceMappingURL=first-last-endpoint.js.map