"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var es6_shim_1 = require("es6-shim");
var rx = require("rxjs");
var Connection = /** @class */ (function () {
    function Connection(partners, idx) {
        this.input = new rx.Subject();
        this.input.subscribe(null, function (error) { partners[idx].input.error(error); }, function () { partners[idx].input.complete(); });
        this.output = new rx.Subject();
        this.output.subscribe(function (data) { partners[idx].input.next(data); }, function (error) { partners[idx].input.error(error); }, function () { partners[idx].input.complete(); });
    }
    return Connection;
}());
exports.Connection = Connection;
var MemoryEndpoint = /** @class */ (function () {
    function MemoryEndpoint() {
        this.serviceMap = new es6_shim_1.Map();
    }
    MemoryEndpoint.prototype.listen = function (cname) {
        if (this.serviceMap.has(cname)) {
            return null;
        }
        var partners = [];
        var ret = new Connection(partners, 1);
        partners.push(ret);
        this.serviceMap.set(cname, partners);
        return ret;
    };
    MemoryEndpoint.prototype.connect = function (cname) {
        var partners = this.serviceMap.get(cname);
        if (!partners && partners.length != 1) {
            return null;
        }
        var ret = new Connection(partners, 0);
        partners.push(ret);
        return ret;
    };
    return MemoryEndpoint;
}());
exports.MemoryEndpoint = MemoryEndpoint;
exports.default = MemoryEndpoint;
//# sourceMappingURL=memory-endpoint.js.map