"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rx = require("rxjs");
var StdInOutEndpoint = /** @class */ (function () {
    function StdInOutEndpoint() {
        this.input = rx.Observable.create(function (observer) {
            process.stdin.on('data', function (stuff) {
                observer.next(stuff.toString('utf-8'));
            });
            process.stdin.on('error', function (error) {
                observer.error(error);
            });
            process.stdin.on('close', function () {
                observer.complete();
                process.exit(0);
            });
        });
        this.output = new rx.Subject();
        this.output.subscribe(function (a) { return process.stdout.write(a); });
    }
    return StdInOutEndpoint;
}());
exports.StdInOutEndpoint = StdInOutEndpoint;
exports.default = StdInOutEndpoint;
//# sourceMappingURL=std-in-out-endpoint.js.map