"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var memory_endpoint_1 = require("../src/memory-endpoint");
describe('Endpoint memory (communication)', function () {
    it('client -> server', function (done) {
        var memEp = new memory_endpoint_1.default();
        var server = memEp.listen('cName');
        var client = memEp.connect('cName');
        server.input.subscribe(function (data) { chai_1.assert.equal('CTS', data); }, function () { chai_1.assert.fail(); }, function () { done(); });
        client.output.next('CTS');
        client.output.complete();
    });
    it('server -> client', function (done) {
        var memEp = new memory_endpoint_1.default();
        var server = memEp.listen('cName');
        var client = memEp.connect('cName');
        client.input.subscribe(function (data) { chai_1.assert.equal('PONG', data); }, function () { chai_1.assert.fail(); }, function () { done(); });
        server.output.next('PONG');
        server.output.complete();
    });
    it('(echo) client -> server -> client', function (done) {
        var memEp = new memory_endpoint_1.default();
        var server = memEp.listen('cName');
        var client = memEp.connect('cName');
        server.input.subscribe(function (data) {
            chai_1.assert.equal('PING', data);
            server.output.next(data);
        });
        client.input.subscribe(function (data) { chai_1.assert.equal('PING', data); }, function () { chai_1.assert.fail(); }, function () { done(); });
        client.output.next('PING');
        client.output.complete();
    });
});
//# sourceMappingURL=endpoint-test.js.map