"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var execFile_endpoint_1 = require("../src/execFile-endpoint");
var first_last_endpoint_1 = require("../src/first-last-endpoint");
var path = require("path");
var echoProcessHelper = path.join('dist', 'test', 'helper', 'process-echo.js');
describe('Endpoint message parser', function () {
    it('echo test', function (done) {
        var eep = execFile_endpoint_1.default.command(process.execPath, [echoProcessHelper]);
        var flep = new first_last_endpoint_1.default('__BEG__', '__END__', eep);
        var nextish = 4;
        var count = 0;
        flep.input.subscribe(function (data) {
            chai_1.assert.equal("Hello World " + count++, data);
            if (nextish == count) {
                flep.output.complete();
            }
        }, function (error) { chai_1.assert.fail(); }, function () {
            chai_1.assert.equal(count, nextish);
            done();
        });
        for (var i = 0; i < nextish; ++i) {
            flep.output.next("Hello World " + i);
        }
    });
    it('echo test with client crashes', function (done) {
        var eep = execFile_endpoint_1.default.command(process.execPath, [echoProcessHelper]);
        var flep = new first_last_endpoint_1.default('__BEG__', '__END__', eep);
        flep.input.subscribe(function (data) {
            chai_1.assert.equal("Hello World 0", data);
        }, function (err) {
            chai_1.assert.equal(err.status, 66);
            done();
        }, function () {
            chai_1.assert.fail();
        });
        flep.output.next("Hello World 0");
        flep.output.next("CORE");
    });
});
//# sourceMappingURL=msg-parser-test.js.map